unit Umain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls,
  CalkView, Geobox, Gauges,
  OExoTab,  {liste des exercices }
  UScores,  {gestion des scores LiliMath }
  About,    {dialogue A propos}
  {Inscrip,}  {dialogue d'inscription d'un nouvel lve }
  {CodeDlg,}  {dialogue d'entre d'un code lve }
  Utils, Menus, MPlayer, Buttons;    {divers }

const
 Wm_AfficheExo = 1;
 Wm_AfficheChoix = 2;
 Wm_FinExo = 3;

type
  TMainForm = class(TForm)
    ImageExo: TImage;
    FeuilleDeCalcul: TFeuilleDeCalcul;
    MemoEnonce: TMemo;
    ImageoBox: TImageoBox;
    EditReponse: TEdit;
    Gauge: TGauge;
    IdentLabel: TLabel;
    MainMenu: TMainMenu;
    MenuFichier: TMenuItem;
    MenuQuitter: TMenuItem;
    N1: TMenuItem;
    MenuAidegen: TMenuItem;
    MenuAideCours: TMenuItem;
    MenuAideContext: TMenuItem;
    N2: TMenuItem;
    MenuApropos: TMenuItem;
    MediaPlayer: TMediaPlayer;
    MenuOptions: TMenuItem;
    MenuMusfond: TMenuItem;
    ImageBmp: TImage;
    MenuBruitages: TMenuItem;
    ImageChoix: TImage;
    ListBoxChoix: TListBox;
    LabelNumero: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditReponseKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MenuAideContextClick(Sender: TObject);
    procedure MenuQuitterClick(Sender: TObject);
    procedure MenuAproposClick(Sender: TObject);
    procedure MenuAideCoursClick(Sender: TObject);
    procedure MenuAidegenClick(Sender: TObject);
    procedure MediaPlayerNotify(Sender: TObject);
    procedure MenuMusfondClick(Sender: TObject);
    procedure MenuBruitagesClick(Sender: TObject);
    procedure ImageExoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageExoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure ListBoxChoixDblClick(Sender: TObject);
    procedure ListBoxChoixKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations private }
  public
    { Dclarations public }
    { Variables }
    ExoTab:TExoTab;      {liste des exercices }
    NumExo,              {numro de l'exercice en cours }
    NivAide,             {numro de l'aide contextuelle }
    NbEssais : Integer;  {nombre d'essais de rponse }
    ScoreTotal : Real;   {score total des exercices effectus }
    ScoCode : String[8]; {code de l'lve }
    NomImage : String;   {nom fichier image }
    ExoFile  : String;   {nom du fichier d'exercices en cours}
    ExoDesc  : String;   {titre de l'exercice en cours}
    ListeChoix : TStringList; {liste des fichiers disponibles }
    { procdures et fonctions }
    procedure ChargeExo;      {chargement de l'exercice suivant }
    procedure Verification;   {vrification de la rponse }
    procedure FigureImageo;   {dessin de la figure Imageo }
    procedure LireFichier;    {lecture du fichier complet ExoFile}
    procedure LireEleve(S:String);   {lecture du fichier sco de l'lve }
    procedure ScoreMsg;       {message affichant le rsultat final +
                               enregistrement dans le fichier sco }
    procedure WMAfficheExo(var Msg:TMessage);
     message WM_USER+WM_AfficheExo;
    procedure WMAfficheChoix(var Msg:TMessage);
     message WM_USER+WM_AfficheChoix;
    procedure WMFinExo(var Msg:TMessage);
     message WM_USER+WM_FinExo;
    procedure WMERASEBKGND(var Msg:TMessage);
     message WM_ERASEBKGND;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormShow(Sender: TObject);
{ On calcule ici les coordonnes de tous les composants insrs pour
  qu'ils prennent leur place par rapport aux images,
  puis on lance la musique de fond.
  Note : tous les composants sont encore invisibles, leur proprit
  Visible est  false; on les fera apparatre ou disparatre en
  utilisant les mthodes Show et Hide }

begin
 Width:=Mini(800,Screen.Width);
 Height:=Mini(600,Screen.Width);
 { image pour exercice en cours }
 ImageExo.Top:=(Height-ImageExo.Height) div 2 - 30;
 ImageExo.Left:=(Width-ImageExo.Width) div 2;
 FeuilleDeCalcul.Top:=ImageExo.Top+56-28;
 FeuilleDeCalcul.Left:=ImageExo.Left+68-52;
 MemoEnonce .Top:=ImageExo.Top+96-28;
 MemoEnonce.Left:=ImageExo.Left+368-52;
 ImageoBox.Top:=ImageExo.Top+238-28;
 ImageoBox.Left:=ImageExo.Left+338-52;
 ImageBmp.Top:=ImageExo.Top+238-28;
 ImageBmp.Left:=ImageExo.Left+338-52;
 EditReponse.Top:=ImageExo.Top+390-28;
 EditReponse.Left:=ImageExo.Left+463-52;
 Gauge.Top:=ImageExo.Top+360-28;
 Gauge.Left:=ImageExo.Left+98-52;
 LabelNumero.Top:=ImageExo.Top+296-28;
 LabelNumero.Left:=ImageExo.Left+232-52;
 { image pour slection d'un exercice }
 ImageChoix.Top:=(Height-ImageChoix.Height) div 2 -30;
 ImageChoix.Left:=(Width-ImageChoix.Width) div 2;
 ListBoxChoix.Top:=ImageChoix.Top+38;
 ListBoxChoix.Left:=ImageChoix.Left+47;
 ListBoxChoix.Width:=ImageChoix.Width-93;
 ListBoxChoix.Height:=ImageChoix.Height-116;
 { on lance la musique de fond }
 if MenuMusFond.Checked then
  begin
   MediaPlayer.Play;
   MediaPlayer.Notify:=true;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
{initialisation de la fentre :
  - on initialise les variables
  - on lit le fichier ini pour la gestion du son
  - on regarde s'il y a des paramtres sur la ligne de commandes
    et on les traite si c'est le cas : on peut avoir un nom de
    fichier exo et un code LiliMath, le code LiliMath tant toujours
    pass en dernier }
var
 S: String;
 n,i : Integer;
 ok : Boolean;
 Id : TIdent;
begin
 Screen.Cursors[1]:=LoadCursor(HInstance,'DOIGT');
 Randomize;  {pour que le hasard soit hasardeux }
 {initialisation des variables }
 Exotab:=nil;
 ScoCode:='';
 ExoFile:='';
 ExoDesc:='';
 ListeChoix:=nil;
 InitScoPath;    {o sont les fichiers scores ? }
 { initialisation  partir du fichier ini pour le son }
 LireIni;
 MediaPlayer.FileName:=ExtractFilePath(Application.ExeName)+
             'sons\'+IniRec.MusFond;
 MediaPlayer.AutoRewind:=true;
 MediaPlayer.AutoEnable:=true;
 if IniRec.opMusFond=1 then
  begin
   MenuMusFond.Checked:=true;
   MediaPlayer.Open;
  end
 else MenuMusFond.Checked:=false;
 if IniRec.opBruitage=1 then MenuBruitages.Checked:=true
 else MenuBruitages.Checked:=false;
 { on tudie les paramtres de la ligne de commande }
 n:=paramcount;
 if n>0 then {s'il y a des paramtres sur la ligne de commande }
  begin
   {on commence par rechercher un code lve }
   ok:=false; {ok indique que le paramtre est un code lve }
   i:=1;      {compteur de paramtres }
   repeat
    S:=paramstr(i);
    ok:=CodeOk(S);
    if not ok then inc(i);
   until ok or (i>n);
   if ok then  {on a trouv un fichier sco }
    begin
     LireEleve(S); {on lit le fichier sco }
    end
   else IdentLabel.Caption:='';
  end;
 {on regarde si le premier paramtre n'est pas un fichier de donnes }
 if ((not ok) and (n>0)) or (ok and (n>1)) then
  begin
   ExoFile:=paramstr(1);
   if FileExists(ExoFile) then
    ExoDesc:=ExtractFileName(ExoFile)
   else ExoFile:='';
  end
 else
  begin
   ExoFile:='';
  end;
 {le contenu de ExoFile indique s'il est ncessaire de lancer l'cran
  de slection : c'est la mthode Paint qui s'en charge }
end;

procedure TMainForm.LireEleve(S:String);
{on lit nom, prnom et classe dans le fichier sco }
var Id:TIdent;
begin
 ScoCode:=S;
 ReadIdent(ScoCode,Id);
 S:=Id.Nom+' '+Id.Prenom+' '+Id.Classe;
 {conversion ASCII/ANSI pour tre compatible avec les anciens fichiers sco }
 Asci2Ansi(S);
 IdentLabel.Caption:=S; {affichage des renseignements }
end;

procedure TMainForm.LireFichier;
{lecture du fichier d'exercices }
begin
 {si un fichier est dj charg, on vide }
 if exotab<>nil then exotab.free;
 NumExo:=-1;
 NivAide:=-1;
 NbEssais:=0;
 ScoreTotal:=0;
 Gauge.Progress:=0;
 {ExoFile:=S;}             {nouveau nom de fichier }
 exotab:=TExoTab.Create; {nouvelle liste }
 with exotab do
  begin {on lit le fichier }
   LireFichier(ExoFile);
   if ErrorFlag<>0 then  {en cas d'erreur ...}
    begin
     ShowInfo('Info',GetErrorMsg);
     Errorflag:=0;
     ExoFile:='';
    end
   else
    begin {tout s'est bien pass }
     Caption:='Exocalc '+(ExoDesc); {modifier le titre de la fentre }
     ChargeExo; {charger le premier exercice }
    end;
  end;
end;

procedure TMainForm.ChargeExo;
{chargement de l'exercice suivant }
var L:TStringList;
    i:Integer;
begin
 if Exotab.Afaire=0 then exit; {il n'y a rien  faire }
 inc(NumExo); {le numro de l'exercice augmente d'une unit }
              {comme on a initialis  -1, le 1er exercice a le numro 0 }
 if NumExo<Exotab.Afaire then {il reste des exercices  faire }
  begin
   {rinitialisations diverses }
   NbEssais:=0; {pas encore d'essai de rponse }
   NivAide:=-1; {pas encore d'aide contextuelle demande }
   FeuilleDeCalcul.Clear; {effacer la feuille de calcul }
   {mise  jour du label numro }
   LabelNumero.Caption:=' Exercice  '+IntToStr(NumExo+1)+' sur '+
                          IntToStr(ExoTab.Afaire);
   {mise  jour de l'nonc }
   MemoEnonce.Clear;
   L:=Exotab.GetExoRec(NumExo).Enonce;
   for i:=0 to L.Count-1 do MemoEnonce.Lines.Add(L[i]);
   MemoEnonce.SelStart:=0;
   {la rponse est dans la variable X }
   FeuilleDeCalcul.DefVar('X',Exotab.GetExoRec(NumExo).Reponse);
   {image associe  l'nonc }
   {s'il y a un nom de fichier image, on ajoute le chemin d'accs }
   NomImage:=Exotab.GetExoRec(NumExo).Image;
   if NomImage<>'' then
    begin
     NomImage:=ExoTab.ExoPath+NomImage;
     ImageBMP.Picture.LoadFromFile(NomImage);
     ImageoBox.Hide;
     ImageBMP.Show;
    end
   else
    begin
     FigureImageo;
     ImageBMP.Hide;
     ImageoBox.Show;
    end;
   {s'il n'y a ni image ni figure on met l'image par dfaut }
   {if (NomImage='') then NomImage:='exocalc.bmp';}
   {if NomImage<>'' then } {il faut afficher un fichier bmp }
  end
 else {plus rien  faire, on sort ou on change d'exercice }
  begin
   if ListeChoix<>nil then { il y a des exercices  choisir }
    PostMessage(Handle,WM_User+Wm_FinExo,0,0)
   else Close;
  end;
end;

procedure TMainForm.Verification;
{ procdure de vrification de la rponse }
var rep:Real;
    err:Integer;
    suivant:Boolean; {indique si on passe  l'exercice suivant }
    S : String;
begin
 if ExoTab.Afaire=0 then exit; {il n'y a rien  faire }
 suivant:=false;
 {y a-t-il une rponse inscrite ? }
 if EditReponse.Text='' then
  begin
   ShowInfo('Info','Il faut inscrire une rponse.');
   exit;
  end;
 {valuer la rponse }
 val(EditReponse.Text,rep,err);
 if err<>0 then ShowInfo('Info','Nombre mal crit!')
 else  {on a trouv une rponse interprtable }
  begin
   if rep=Exotab.GetExoRec(NumExo).Reponse then
    begin  {c'est la bonne rponse }
     S:=ExtractFilePath(Application.ExeName)+'sons\'+IniRec.SonBon;
     PlayWav(S);
     ShowInfo('Info','Tu as raison. Bonne rponse.');
     Suivant:=true;
    end
   else
    begin  {la rponse est fausse }
     S:=ExtractFilePath(Application.ExeName)+'sons\'+IniRec.Sonfaux;
     PlayWav(S);
     inc(NbEssais);  {compter un essai supplmentaire }
     if NbEssais>=IniRec.MaxEssais then  { on dpasse la limite autorise }
      begin
       dec(NbEssais);
       suivant:=true;
       ShowInfo('Erreur','C''est encore faux.'+chr(13)+'On passe  l''exercice suivant.');
      end
      else ShowInfo('Erreur','Tu te trompes. Recommence!');
           {simple message d'erreur }
    end;
   if suivant then {il faut passer  l'exercice suivant }
    begin
     {mise  jour du score total et de la barre de progression }
     {c'est ici qu'on compte les points }
     ScoreTotal:=ScoreTotal+(100/ExoTab.Afaire)*
          (IniRec.MaxEssais-NbEssais)/IniRec.MaxEssais;
     Gauge.Progress:=round(ScoreTotal);
     {chargement du nouvel exercice }
     ChargeExo;
     {effacement de la rponse }
     EditReponse.Text:='';
    end;
  end;
 {on active la feuille de calcul }
 FeuilleDecalcul.SetFocus;
end;

procedure TMainForm.EditReponseKeyPress(Sender: TObject; var Key: Char);
{gestion de l'appui sur Entre dans la ligne d'dition de la rponse }
begin
 if Key=#13 then  {on a appuy sur Entre }
  begin
   Verification; {vrification de la rponse }
   Key:=#0;      {annulation de l'appui sur la touche }
  end;
end;

procedure TMainForm.ScoreMsg;
{message donnant le score final et enregistrement }
var
 S: String;      {message  afficher }
 Score: TScore;
 Id : TIdent;
begin
 if ExoFile='' then exit; {rien  faire }
 {on prpare l'enregistrement TScore }
 with Score do
  begin
   Theme:=ExtractFileName(ExoFile);
   { le thme de l'exercice est le nom du fichier de donnes }
   Prog:=ExtractFileName(Application.ExeName);
   { le nom de l'exercice est le nom du fichier exe }
   NbEssais:=0;
   Result:=0;
  end;
 if ScoCode<>'' then {il y a un code d'lve }
  GetScore(ScoCode, Score, Id) {on lit le dernier rsultat obtenu }
 else Score.Result:=-1;        {sinon pas de rsultat  enregistrer }
 inc(Score.NbEssais); {essai supplmentaire }
 {la variable S doit contenir le message  afficher }
 if ScoreTotal>=75 then {c'est russi }
  begin
   S:='Exercice russi  '+IntToStr(round(ScoreTotal))+'%';
   {on compare au rsultat prcdent }
   if Score.Result>ScoreTotal then
    S:=S+chr(13)+'Tu as dj fait mieux !'
   else S:=S+chr(13)+'Bravo...';
  end
 else if ScoreTotal>0 then {en cas d'chec }
  begin
   S:='Echec. Tu n''obtiens que '+IntToStr(round(ScoreTotal))+'%.';
   if (Score.Result>0) and (Score.Result<ScoreTotal) then
    S:=S+chr(13)+'Tu as progress, il faut continuer.'
   else S:=S+chr(13)+'Il faudra recommencer.'
  end
 else S:=''; {rien d'intressant  dire, l'lve n'a rien fait }
 if S<>'' then {affichage du message }
  ShowInfo('Fin de l''exercice',S);
 if ScoCode<>'' then {enregistrement du rsultat dans le fichier sco }
  begin
   if Score.Result<Gauge.Progress then
    Score.Result:=Gauge.Progress;
   ScoreUpdate(ScoCode,Score);
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
{juste avant la fermeture de la fentre }
begin
 { ScoreMsg; } {affichage et enregistrement du score }
 { si l'cran exercice est visible, on l'efface }
 if ImageExo.Visible then SendMessage(Handle,Wm_User+Wm_FinExo,1,0);
 { fermeture du fichier d'aide s'il est ouvert }
 Application.HelpCommand(Help_Quit,0);
 { libration mmoire }
 if ListeChoix<>nil then ListeChoix.Free;
 EcrireIni;
end;

procedure TMainForm.FigureImageo;
{affichage d'une figure Imageo }
var L:TStringList;
    r:Real;
begin
 {on lit le script Imageo }
 L:=Exotab.GetExorec(NumExo).Figure;
 {on ajoute les couleurs par dfaut }
 with ImageoBox do
  begin
   DessineListe(L);
   ExecString('couleurfond=blanc');
   ExecString('couleurtrace=noir');
   ExecString('couleurchoisi=noir');
   ExecString('couleurmobile=noir');
   { on modifie l'chelle en multipliant par 1.5 }
   MultEchelle(1.5);
  end;
 { il n'y a pas d'image bmp }
 NomImage:='';
 { on procde  l'affichage }
 ImageoBox.Repaint;
end;

procedure TMainForm.MenuAideContextClick(Sender: TObject);
{ on affiche l'aide contextuelle }
var L:TStringList;
    S,R:String;
    i:Integer;
begin
 if (ExoTab=nil) or (ExoTab.Count=0) then {pas d'exercice charg }
  begin
   ShowInfo('Info','Il faut ouvrir un fichier d''exercices.');
   exit;
  end;
 {on rcupre la liste des aides contextuelles }
 L:=ExoTab.GetExoRec(NumExo).Aide;
 if L.Count=0 then  {il n'y en a pas }
  begin
   FeuilleDeCalcul.Lines.Add('Pas d''aide pour cet exercice');
   exit;
  end;
 {on a trouv des aides contextuelles }
 inc(NivAide); {on passe  l'aide suivante; comme l'initialisation
                est  -1, la 1re aide a le numro 0 }
 {si on dpasse le nombre d'aides prvues on reprend au dbut }
 if NivAide>=L.Count then exit; {NivAide:=0;}
 {on rcupre le message d'aide }
 S:=L[NivAide];
 {on remplace les # par des sauts de ligne }
 R:='';
 for i:=1 to length(S) do
  begin
   if S[i]<>'#' then R:=R+S[i]
   else
    begin
     FeuilleDeCalcul.Lines.Add(R);
     R:='';
    end;
  end;
 if R<>'' then FeuilleDeCalcul.Lines.Add(R);
 FeuilleDeCalcul.Lines.Add('');
 { l'aide est affiche, on ractive la feuille de calcul }
 FeuilleDeCalcul.SetFocus;
end;

procedure TMainForm.MenuQuitterClick(Sender: TObject);
{ menu Quitter }
begin
 close;
end;

procedure TMainForm.MenuAproposClick(Sender: TObject);
{menu A Propos...}
begin
 AboutBox:=TAboutBox.Create(self);
 AboutBox.ShowModal;
 AboutBox.Free;
end;

procedure TMainForm.MenuAideCoursClick(Sender: TObject);
{ on affiche le cours }
var S : String;
begin
 if (ExoTab=nil) or (ExoTab.Count=0) then {pas d'exercice charg }
  begin
   ShowInfo('Info','Il faut ouvrir un fichier d''exercices.');
   exit;
  end;
 {on lit le nom du fichier de cours et on change son extension
  qui tait .aid pour le DOS }
 S:=ExoTab.Cours;
 S:=ChangeFileExt(S,'.hlp');
 {on envoie l'aide }
 Application.HelpFile:=S;
 Application.HelpJump('Main_Index');
end;

procedure TMainForm.MenuAidegenClick(Sender: TObject);
{ aide gnrale sur EXOCALC }
begin
 Application.HelpFile:='EXOCALC.HLP';
 Application.HelpCommand(HELP_CONTENTS,0);
 Application.HelpJump('');
end;

procedure TMainForm.MediaPlayerNotify(Sender: TObject);
{ sert  reprendre la musique de fond lorsqu'elle est termine }
begin
 if (MediaPlayer.NotifyValue=nvSuccessFul) and MenuMusFond.Checked then
  begin
   MediaPlayer.Play;
   MediaPlayer.Notify:=true;
  end;
end;

procedure TMainForm.MenuMusfondClick(Sender: TObject);
{ menu Musique de fond }
begin
 if MenuMusFond.Checked then
  begin
   MenuMusFond.Checked:=false;
   MediaPlayer.Close;
   IniRec.opMusFond:=0;
  end
 else
  begin
   MenuMusFond.Checked:=true;
   IniRec.opMusFond:=1;
   MediaPlayer.Open;
   MediaPlayer.Play;
   MediaPlayer.Notify:=true;
  end;
end;

procedure TMainForm.MenuBruitagesClick(Sender: TObject);
{ menu Bruitages }
begin
 MenuBruitages.Checked:=not MenuBruitages.Checked;
 if MenuBruitages.Checked then
  IniRec.opBruitage:=1
 else IniRec.opBruitage:=0;
end;

procedure TMainForm.ImageExoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ gestion des clics sur les boutons; on n'utilise pas l'vnement
  clic pour avoir accs aux coordonnes }
begin
 if (x>39) and (x<109) and (y>227) and (y<251) then
  MenuAideContext.Click
 else if (x>37) and (x<138) and (y>259) and (y<288) then
  MenuAideCours.Click
 else if (x>34) and (x<144) and (y>294) and (y<321) then
  Verification;
end;

procedure TMainForm.ImageExoMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
{ changement d'aspect de la souris sur les boutons }
begin
 if (x>39) and (x<109) and (y>227) and (y<251) then
  Cursor:=1
 else if (x>37) and (x<132) and (y>259) and (y<288) then
  Cursor:=1
 else if (x>34) and (x<138) and (y>294) and (y<321) then
  Cursor:=1
 else Cursor:=crDefault;
end;

procedure TMainForm.WMAfficheChoix(var Msg:TMessage);
{ affichage de l'cran de choix d'un fichier }
var i:Integer;
begin
 ImageChoix.Show;
 {ImageChoix.Repaint;}
 { la 1re fois il faut remplir la liste des choix; on saura
   qu'il n'y a pas eu de fichier pass en paramtre grce 
   ListeChoix qui sera diffrent de nil }
 if ListeChoix=nil then
  begin
   ListeChoix:=TStringList.Create;
   DonneChoix(ListeChoix);
   for i:=0 to ListeChoix.Count-1 do
    begin
     ListBoxChoix.Items.Add(ExtractFileName(ListeChoix[i]));
    end;
  end;
 { on affiche la liste }
 ListBoxChoix.Show;
 ListBoxChoix.SetFocus;
end;

procedure TMainForm.WMAfficheExo(var Msg:TMessage);
{ affichage de l'cran exercice }
var
 i:Integer;
 OldHeight,OldTop : Integer;
 S:String;
begin
 { effet sonore }
 S:=ExtractFilePath(Application.ExeName)+'sons\'+IniRec.SonInit;
 PlayWav(S);
 { effet visuel }
 OldHeight:=ImageExo.Height;
 OldTop:=ImageExo.Top;
 if IniRec.opScroll=1 then
  begin
   ImageExo.Top:=OldTop+OldHeight;
   ImageExo.Height:=0;
   ImageExo.Visible:=true;
   i:=0;
   while i<OldHeight do
    begin
     ImageExo.Top:=maxi(OldTop+OldHeight-i, OldTop);
     ImageExo.Height:=mini(i, OldHeight);
     ImageExo.Repaint;
     i:=i+IniRec.defil
    end;
  end
 else ImageExo.Show;
 ImageExo.Top:=OldTop;
 ImageExo.Height:=OldHeight;
 { lecture du fichier d'exercices et affichage des composants }
 { la lecture du fichier initialise les variables lies  un
   exercice et provoque le chargement du 1er exercice }
 LireFichier;
 Gauge.Show;
 FeuilleDeCalcul.Show;
 EditReponse.Show;
 MemoEnonce.Show;
 LabelNumero.Show;
 { la figure Imageo ou l'image BMP sont affiches lors du
   chargement de l'exercice }
 FeuilleDeCalcul.SetFocus;
end;

procedure TMainForm.WMFinExo(var Msg:TMessage);
{ effacement de l'cran d'exercice }
var
 OldTop : Integer;
 OldHeight : Integer;
 i : Integer;
 S : String;
 R : TRect;
begin
 { affichage du rsultat final }
 ScoreMsg;
 { il n'y a plus d'exercices en cours }
 ExoFile:='';
 Caption:='Exocalc';
 { on efface les composants }
 FeuilleDeCalcul.Hide;
 EditReponse.Hide;
 ImageoBox.Hide;
 ImageBmp.Hide;
 Gauge.Hide;
 MemoEnonce.Hide;
 LabelNumero.Hide;
 { effet sonore }
 S:=ExtractFilePath(Application.ExeName)+'sons\'+IniRec.SonInit;
 PlayWav(S);
 { effet visuel }
 OldTop:=ImageExo.Top;
 OldHeight:=ImageExo.Height;
 if IniRec.opScroll=1 then
  begin
   i:=0;
   while i<OldHeight do
    begin
     ImageExo.Top:=mini(OldTop+i,OldTop+OldHeight);
     ImageExo.Height:=maxi(OldHeight-i,0);
     ImageExo.Repaint;
     i:=i+IniRec.defil;
     { effacer la partie restante de l'image prcdente }
     R:= Rect(ImageExo.Left, ImageExo.Top-IniRec.Defil, 
              ImageExo.Left+ImageExo.Width, ImageExo.Top+IniRec.Defil);
     Canvas.Brush.Color := clBlack;
     Canvas.FillRect(R);
    end;
  end;
 ImageExo.Hide;
 ImageExo.Top:=OldTop;
 ImageExo.Height:=OldHeight;
 { si ncessaire on raffiche l'cran de choix de fichier }
 if (ListeChoix<>nil) and (Msg.WParam<>1) then
  PostMessage(Handle,Wm_User+Wm_AfficheChoix,0,0);
end;

procedure TMainForm.WMERASEBKGND(var Msg:TMessage);
{ empche le fond de la fentre de se redessiner }
{ vite un clignotement }
begin
 Msg.Result:=1;
end;

procedure TMainForm.FormPaint(Sender: TObject);
{ affichage de l'cran : se fait selon la valeur de ExoFile }
var R: TRect;
begin
 R:= Rect(0, IdentLabel.Height, ClientWidth, ClientHeight);
 Canvas.Brush.Color := clBlack;
 Canvas.FillRect(R);
 if ExoFile='' then
  begin
   if not ImageChoix.Visible then
    PostMessage(Handle,WM_User+WM_AfficheChoix,0,0);
  end
 else if not ImageExo.Visible then
  PostMessage(Handle,WM_User+WM_AfficheExo,0,0);
end;

procedure TMainForm.ListBoxChoixDblClick(Sender: TObject);
{ choix d'un exercice par double-clic }
begin
 if ListBoxChoix.ItemIndex>=0 then
  begin
   DonneInfoExo(ListBoxChoix.ItemIndex+1,ExoFile,ExoDesc);
   if ExoFile<>'' then
    begin
     ListBoxChoix.Hide;
     ImageChoix.Hide;
     Repaint;
    end;
  end
 else MenuQuitter.Click;
end;

procedure TMainForm.ListBoxChoixKeyPress(Sender: TObject; var Key: Char);
{ choix d'un exercice par appui sur Entre }
begin
 if Key=#13 then
  begin
   ListBoxChoixDblClick(Sender);
   Key:=#0;
  end;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (Key = Vk_F2) and (SsAlt in Shift) and ImageExo.Visible then
  begin
   ChargeExo;
  end;
 if (Key = Vk_F3) and (SsAlt in Shift) and ImageExo.Visible then
  begin
   EditReponse.SetFocus;
  end;
end;

end.
