unit Utils;
{ procdures diverses pour WExoCalc }

interface
uses WinTypes, WinProcs, SysUtils, IniFiles, UScores, Classes,
     Forms, Controls, MMSystem;

type
 TIniRec = record
  opScroll  : Integer;
  opMusFond  : Integer;
  opBruitage : Integer;
  defil : Integer;
  maxEssais : Integer;
  MusFond : String[80];
  SonBon : String[80];
  SonFaux : String[80];
  SonInit : String[80];
  end;

var IniRec : TIniRec;

{conversions ASCII/ANSI pour pouvoir lire les anciens fichiers LiliMath }
procedure Ansi2Asci(var S:String);
procedure Asci2Ansi(var S:String);
{initialisation de ScoPath qui contient le chemin d'accs aux fichiers sco }
procedure InitScoPath;
{gestion du fichier ini}
procedure LireIni;
procedure EcrireIni;
{liste des exo disponibles}
procedure DonneChoix(L:TStringList);
{adresse et titre d'un exercice}
procedure DonneInfoExo(n:Integer; var Adresse,Titre:String);
{bruitages}
procedure PlayWav(Nom:String);
{messages}
procedure ShowInfo(Titre,Contenu:String);
{minimum et maximum}
function mini(a,b:Integer):Integer;
function maxi(a,b:Integer):Integer;

implementation

function mini(a,b:Integer):Integer;
begin
 if a<b then Result:=a else Result:=b;
end;

function maxi(a,b:Integer):Integer;
begin
 if a>b then Result:=a else Result:=b;
end;

procedure ShowInfo(Titre,Contenu:String);
{procdure d'affichage de messages divers }
var
 tit,cont:String;
 w : TWinControl;
begin
 Tit:=Titre+#0; Cont:=Contenu+#0;
 w:=Application.MainForm.ActiveControl;
 Application.MessageBox(@Cont[1],@Tit[1],MB_Ok+MB_ICONEXCLAMATION);
 if (w<>nil) and (w.Visible) then W.SetFocus;
end;


procedure PlayWav(Nom:String);
{ bruitage }
begin
 if IniRec.opBruitage=0 then exit;
 Nom:=Nom+#0;
 sndPlaySound(@Nom[1], 0);
end;

procedure DonneChoix(L:TStringList);
{ liste des exos disponibles lue dans le fichier ini }
var IniFile:TIniFile;
    S,Si:String;
    i,n:Integer;
begin
 S:=Application.ExeName;
 S:=ChangeFileExt(S,'.ini');
 try
  IniFile:=TIniFile.Create(S);
  with IniFile do
   begin
    n:=ReadInteger('MENU','nombre',0);
    for i:=1 to n do
     begin
      Si:='A'+IntToStr(i);
      S:=ReadString('MENU',Si,'');
      if S<>'' then L.Add(S);
     end;
   end;
 finally
  IniFile.Free;
 end;
end;

procedure DonneInfoExo(n:Integer; var Adresse,Titre:String);
var IniFile:TIniFile;
    S:String;
begin
 Adresse:='';
 Titre:='';
 S:=Application.ExeName;
 S:=ChangeFileExt(S,'.ini');
 try
  IniFile:=TIniFile.Create(S);
  with IniFile do
   begin
    S:='A'+IntToStr(n);
    Titre:=ReadString('MENU',S,'');
    S[1]:='B';
    Adresse:=ReadString('MENU',S,'');
    if S<>'' then S:=ExtractFilePath(Application.ExeName)+S;
   end;
 finally
  IniFile.Free;
 end;
end;

procedure LireIni;
var IniFile:TIniFile;
    S:String;
begin
 S:=Application.ExeName;
 S:=ChangeFileExt(S,'.ini');
 try
  IniFile:=TIniFile.Create(S);
  with IniFile,IniRec do
   begin
    maxEssais:=ReadInteger('OPTIONS','maxessais',3);
    if maxEssais<1 then maxEssais:=1
    else if maxEssais>5 then maxEssais:=5;
    opScroll:=ReadInteger('OPTIONS','opscroll',1);
    defil:=ReadInteger('OPTIONS','defil',2);
    opMusFond:=ReadInteger('OPTIONS','opmusfont',1);
    opBruitage:=ReadInteger('OPTIONS','opbruitage',1);
    MusFond:=ReadString('SON','musfond','');
    SonBon:=ReadString('SON','sonbon','');
    SonFaux:=ReadString('SON','sonfaux','');
    SonInit:=ReadString('SON','soninit','');
   end;
 finally
  IniFile.Free;
 end;
end;

procedure EcrireIni;
var IniFile:TIniFile;
    S:String;
begin
 S:=Application.ExeName;
 S:=ChangeFileExt(S,'.ini');
 try
  IniFile:=TIniFile.Create(S);
  with IniFile,IniRec do
   begin
    WriteInteger('OPTIONS','maxessais',maxessais);
    WriteInteger('OPTIONS','opscroll',opScroll);
    WriteInteger('OPTIONS','defil',defil);
    WriteInteger('OPTIONS','opmusfont',opMusFond);
    WriteInteger('OPTIONS','opbruitage',opBruitage);
    WriteString('SON','musfond',MusFond);
    WriteString('SON','sonbon',SonBon);
    WriteString('SON','sonfaux',SonFaux);
    WriteString('SON','soninit',SonInit);
   end;
 finally
  IniFile.Free;
 end;
end;

procedure InitScoPath;
{ on cherche dans LiliMath.ini qui a normalement t cr pendant
  l'installation de LiliMath}
{ si on ne trouve pas on prend le rpertoire qui contient l'excutable }
var IniFile:TIniFile;
begin
 IniFile:=TIniFile.Create('lilimath.ini');
 ScoPath:=IniFile.ReadString('Installation','Dossier','');
 IniFile.Free;
 if ScoPath<>'' then {LiliMath enregistre les scores dans le rpertoire exer6 }
  ScoPath:=ScoPath+'\Exer6'
 else ScoPath:=ExtractFilePath(paramstr(0));
 if ScoPath<>'' then
  if ScoPath[length(ScoPath)]<>'\' then
    ScoPath:=ScoPath+'\';
end;

procedure Ansi2Asci(var S:String);
begin
 S:=S+#0;
 AnsiToOEM(@S[1],@S[1]);
 dec(S[0]);
end;

procedure Asci2Ansi(var S:String);
begin
 S:=S+#0;
 OEMToAnsi(@S[1],@S[1]);
 dec(S[0]);
end;

end.

{              Fin du fichier Utils.pas                      }

Ancienne mthode pour la liste des choix : lire le contenu des rpertoires

Procedure DonneChoix(L:TStringList);
{ lexture de la liste des fichiers exo disponibles }

 procedure LireRep(S:String);
 { procedure rcursive de lecture d'un rpertoire }
 var F:TSearchRec;
     rep:Integer;
 begin
 { on cherche le premier fichier }
 rep:=FindFirst(S+'*.*', faAnyFile, F);
 while rep=0 do  { rep=0 tant qu'on a trouv quelque chose }
  begin
   { si c'est un rpertoire autre que . ou .. on effectue un
     appel rcursif }
   if (F.Name[1]<>'.') and (F.Attr and faDirectory<>0) then
    LireRep(S+F.Name+'\')
   else
    begin
     { si l'extension est .exo on ajoute  la liste }
     if (copy(F.Name,length(F.Name)-3,4)='.exo')
       or (copy(F.Name,length(F.Name)-3,4)='.EXO') then
      L.Add(S+F.Name);
    end;
   rep:=FindNext(F);
  end;
 end;

begin
 LireRep(ExtractFilePath(Application.ExeName));
end;

